--[[
	Druid Cast

	By java aka Express/Toaster

	Es hat mich angekotzt, dass man z.B. versehentlich nicht-Manaklassen
	innervaten kann und Macros spammt, wenn man ein Ziel nicht ressen kann.

	Funktionen als Macros binden!
	/dc innervate	oder /DruidCast innervate
	/dc battleress	oder /DruidCast battleress
	/dc reju	oder /DruidCast reju
	/dc cooldown	oder /DruidCast cooldown
	
   ]]


function DruidCast_OnLoad()

	DEFAULT_CHAT_FRAME:AddMessage(DC_LOADING_MSG);

	SLASH_DruidCast1 = "/DruidCast";
	SLASH_DruidCast2 = "/dc";
	SlashCmdList["DruidCast"] = function(msg)
		DruidCast_SlashCommandHandler(msg);
	end
end


-- Funktion zum Testen auf Cooldown, kopiert von WhisperCast
local function DruidCast_CheckCooldown(spell)
	local i,done,name,id=1,false;
	while (not done) do
		local name = GetSpellName(i,BOOKTYPE_SPELL);
		local start, duration, enable = GetSpellCooldown(i, BOOKTYPE_SPELL);
		restzeit = (start+duration) - GetTime();
		if(restzeit<0)
		then
			restzeit = 0;
		end
		CTrestzeit = CT_RA_FormatTime(restzeit);
		if (not name) then
			done=true;
		elseif (name == spell) then
			if ( start > 0 and duration > 0 and enable > 0) then
				-- Cooldown left
				return true;
			else
				-- There should be no cooldown
				return false;
			end
		end
		i = i+1;
	end
end


function DruidCast_SlashCommandHandler(msg)

	-- Mana Prozentwert ausrechnen
	local DC_MANA = UnitMana("target");
	local DC_MANA_MAX = UnitManaMax("target");
	local DC_MANA_PERCENT = (DC_MANA*100)/DC_MANA_MAX;
	local DC_LEVEL = UnitLevel("target");

	if (string.lower(msg) == "battleress")
	then
		if(UnitIsDeadOrGhost("target") and UnitExists("target") and UnitIsFriend("player","target") and UnitIsPlayer("target") and DruidCast_CheckCooldown(DC_SPELL_REBIRTH) == false) 
		then 
			CastSpellByName(DC_SPELL_REBIRTH);

			if(DC_RESS_CHAN ~= "SAY")
			then
				SendChatMessage("<Druid Cast>: " .. DC_RESS_MSG .. " " .. UnitName("target") .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
			else
				SendChatMessage("<Druid Cast>: " .. DC_RESS_MSG .. " " .. UnitName("target") .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
			end
				SendChatMessage("<Druid Cast>: " .. DC_REBIRTH_MSG .. "!", "WHISPER", GetDefaultLanguage("player"), UnitName("target"));				

		elseif(DruidCast_CheckCooldown(DC_SPELL_REBIRTH) == true)
		then		
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast>: " .. DC_SPELL_REBIRTH .. " " .. DC_ONCOOLDOWN .. " (" .. CTrestzeit ..") !");

		else
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_INVALID_TARGET .."! " .. DC_INVALID_TARGET3 .. "!");
		end


	elseif (string.lower(msg) == "innervate")
	then
		if(not UnitExists("target"))
		then
			SpellTargetUnit("player");
		end

		if(UnitIsFriend("player","target") and UnitIsPlayer("target") and UnitClass("target") ~= DC_CLASS_WARRIOR and UnitClass("target") ~= DC_CLASS_ROGUE and DC_MANA_PERCENT < DC_MANA_CHECK and DC_LEVEL >= 10 and DruidCast_CheckCooldown(DC_SPELL_INNERVATE) == false)
		then
			CastSpellByName(DC_SPELL_INNERVATE);

			if(UnitName("target") ~= UnitName("player"))
			then
				SendChatMessage("<Druid Cast>: " .. DC_INNERVATE_MSG2 .. "!", "WHISPER", GetDefaultLanguage("player"), UnitName("target"));
			end

			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_INNERVATE_MSG .. " " .. UnitName("target") .. "!");

		elseif(DruidCast_CheckCooldown(DC_SPELL_INNERVATE) == true)
		then		
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast>: " .. DC_SPELL_INNERVATE .. " " .. DC_ONCOOLDOWN .. " (" .. CTrestzeit ..") !");
		
		else
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_INVALID_TARGET .."! " .. DC_INVALID_TARGET2 .. "!");
		end

	
	elseif (string.lower(msg) == "reju")
	then
		if(not UnitExists("target"))
		then
			SpellTargetUnit("player");
		end

		if (not UnitIsEnemy("target","player"))
		then
			for i=1,16
			do
				local texture = UnitBuff("target",i); 
				
				if texture ~= nil
				then
					if string.find(string.lower(texture),"rejuvenation")
					then
						DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_INVALID_TARGET .."! " .. DC_INVALID_TARGET4 .. " " .. DC_SPELL_REJU .. "!");
						return end
					else
						break
				end
			end

			CastSpellByName(DC_SPELL_REJU);
		end


	elseif (string.lower(msg) == "cooldown")
	then
		if(DruidCast_CheckCooldown(DC_SPELL_REBIRTH) == false)
		then
			SendChatMessage("<Druid Cast>: " .. DC_SPELL_REBIRTH .. " ".. DC_ISREADY .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		else
			SendChatMessage("<Druid Cast>: " .. DC_COOLDOWN .. " of " .. DC_SPELL_REBIRTH .. ": " .. CTrestzeit, "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		end


		if(DruidCast_CheckCooldown(DC_SPELL_INNERVATE) == false)
		then
			SendChatMessage("<Druid Cast>: " .. DC_SPELL_INNERVATE .. " " .. DC_ISREADY .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		else
			SendChatMessage("<Druid Cast>: " .. DC_COOLDOWN .. " of " .. DC_SPELL_INNERVATE .. ": " .. CTrestzeit, "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		end

	else
		DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> ".. DC_HELP_MSG .. ":");
		DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> /dc battleress  /dc innervate  /dc reju  /dc cooldown");
	end
end	


function DruidCast_OnEvent(event)

end